(function() {
var dropDownNameSuffix = "_DDD";
var itemImageCellClassName = "dxeIIC";
var CONSTANTS = {
 DROPDOWN_COMMAND_APPLY: "Apply",
 DROPDOWN_COMMAND_CLOSE: "Close",
 DROPDOWN_HELPTEXT_CLASS: "dxdd-help",
 DROPDOWN_CAPTION_CLASS: "dxdd-caption",
 DROPDOWN_HEADER_CLASS: "dxdd-header",
 DROPDOWN_MODALVISIBLE_CLASS: "dxdd-vmdd"
};
var DROPDOWN_ELEMENT_VISIBILITY = {
 Never: 0,
 DropDown: 1,
 ModalDropDown: 2,
 Always: 3
};
ASPx.DROPDOWN_ELEMENT_VISIBILITY = DROPDOWN_ELEMENT_VISIBILITY;
var ASPxClientDropDownEditBase = ASPx.CreateClass(ASPxClientButtonEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.DropDown = new ASPxClientEvent();
  this.CloseUp = new ASPxClientEvent();
  this.QueryCloseUp = new ASPxClientEvent();
  this.ddHeightCache = ASPx.InvalidDimension;
  this.ddWidthCache = ASPx.InvalidDimension;
  this.mainElementWidthCache = ASPx.InvalidDimension;
  this.dropDownButtonIndex = -1;
  this.droppedDown = false;
  this.ddButtonPushed = false;
  this.lastSuccessText = "";
  this.isToolbarItem = false;
  this.allowFocusDropDownWindow = false;
  this.pcIsShowingNow = false;
  this.needTimeoutForInputElementFocusEvent = false;
  this.ddButtonsVis = 0;
  this.ddmInput = false;
  this.ddDefCap = true;
  this.ddScrPicker = ASPx.DROPDOWN_ELEMENT_VISIBILITY.Never;
  aspxGetDropDownCollection().Add(this);
 },
 InitializeEvents: function() {
  ASPxClientButtonEditBase.prototype.InitializeEvents.call(this);
  var ddTargets = this.getDropDownEventTargets();
  ddTargets
   .filter(function(trg, index, arr) { return trg && arr.indexOf(trg) === index; })
   .forEach(function(trg) {
    ASPx.Evt.AttachEventToElement(trg, "click", this.onDropDownEvent.bind(this));
    ASPx.Evt.AttachEventToElement(trg, ASPx.TouchUIHelper.touchMouseDownEventName, this.onDropDownEvent.bind(this));
  }.bind(this));
 },
 getDropDownEventTargets: function() {
  return [
   this.GetDropDownItemImageCell(),
   this.GetDropDownButton()
  ];
 },
 onDropDownEvent: function(evt) {
  if(evt.type === this.getDropDownEvent() && ASPx.Evt.IsLeftButtonPressed(evt) && this.GetEnabled())
   return this.OnDropDown(evt);
 },
 getDropDownEvent: function() {
  return this.isDropDownModal() || ASPx.Browser.MobileUI ? "click" : ASPx.TouchUIHelper.touchMouseDownEventName;
 },
 Initialize: function(){
  this.initializePopupControl();
  this.AssignClientAttributes();
  this.InitLastSuccessText();
  if(this.RefocusOnClickRequired()){ 
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "click", function(evt) {
    if(this.GetInputElement() && ASPx.Evt.GetEventSource(evt).id != this.GetInputElement().id) 
     this.ForceRefocusEditor(evt);
   }.aspxBind(this));
  }
  if(this.accessibilityCompliant && ASPx.IsExists(this.GetAccessibilityAssistantElement())) {
   this.GotFocus.AddHandler(function() { 
    this.ariaExplanatoryTextManager.SetHelperLabel(); 
   }.aspxBind(this));
  }
  ASPxClientButtonEditBase.prototype.Initialize.call(this);
 },
 initializePopupControl: function() {
  var pc = this.GetPopupControl();
  if(!pc) return;
  pc.usedInDropDown = true;
  pc.dropDownEditName = this.name;
  pc.setFocusOnCallback = false;
  this.initializeDropDown(pc);
 },
 initializeDropDown: function(pc) {
  pc = pc || this.GetPopupControl();
  if(!pc)
   return;
  if(this.ddmBP !== undefined) {
   pc.AdaptiveModeChanged.AddHandler(function() {
    this.onDropDownModalChanged(pc.GetAdaptiveModalMode());
   }.bind(this));
   pc.PopUp.AddHandler(function() {
    if(pc.GetAdaptiveModalMode())
     this.onDropDownModalChanged(true);
   }.bind(this));
   pc.Closing.AddHandler(function() {
    if(pc.GetAdaptiveModalMode())
     this.onDropDownModalChanged(false);
   }.bind(this));
  }
  this.initializeDropDownCommandButtons(pc);
  if(this.flSettings) {
   this.initializeDropDownContent(pc, this.flSettings.caption, this.flSettings.helpText);
   delete this.flSettings;
  }
 },
 initializeDropDownCommandButtons: function(pc) {
  this.dropDownCommandButtons = {};
  [CONSTANTS.DROPDOWN_COMMAND_APPLY, CONSTANTS.DROPDOWN_COMMAND_CLOSE].forEach(function(cmd) {
   var button = this.createDropDownCommandButtonClientInstance(pc, cmd);
   if(button) {
    button.useSubmitBehavior = false;
    button.causesValidation = false;
    button.accessibilityCompliant = this.accessibilityCompliant;
    button.Click.AddHandler(this.onDropDownCommandButtonClick.bind(this, cmd));
    button.InlineInitialize();
    this.dropDownCommandButtons[cmd] = button;
   }
  }.bind(this));
  this.ensureDropDownApplyCommandState();
 },
 createDropDownCommandButtonClientInstance: function(pc, cmd) {
  var name = pc.name + "_" + cmd;
  return document.getElementById(name) ? new ASPxClientButton(name) : null;
 },
 initializeDropDownContent: function(pc, caption, helpText) {
  if(this.ddmBP === undefined)
   return;
  var container = pc.GetContentContainer(-1);
  if(helpText) {
   var helpTextContainer = container.querySelector(CONSTANTS.DROPDOWN_HELPTEXT_CLASS);
   if(!helpTextContainer) {
    helpTextContainer = document.createElement("div");
    helpTextContainer.innerHTML = this.HtmlEncode(helpText);
    helpTextContainer.className = CONSTANTS.DROPDOWN_HELPTEXT_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
    container.appendChild(helpTextContainer);
   }
  }
  if(caption && this.ddDefCap) {
   var captionContainer = container.querySelector("." + CONSTANTS.DROPDOWN_CAPTION_CLASS);
   if(!captionContainer) {
    captionContainer = document.createElement("div");
    captionContainer.className = CONSTANTS.DROPDOWN_CAPTION_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
    var headerContainer = container.querySelector("." + CONSTANTS.DROPDOWN_HEADER_CLASS);
    if(!headerContainer) {
     headerContainer = document.createElement("div");
     headerContainer.className = CONSTANTS.DROPDOWN_HEADER_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
     container.insertBefore(headerContainer, container.firstChild);
    }
    headerContainer.insertBefore(captionContainer, headerContainer.firstChild);
   }
   captionContainer.innerHTML = this.HtmlEncode(caption);
  }
 },
 InitLastSuccessText: function(){
  var rawText = this.GetTextInternal();
  this.SetLastSuccessText(rawText);
 },
 AssignClientAttributes: function(){
  var element = this.GetDropDownButton();
  if(ASPx.IsExistsElement(element))
   ASPx.Evt.PreventElementDragAndSelect(element, true);
 },
 RefocusOnClickRequired: function(){
  return false;
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientButtonEditBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  if(this.isDropDownModal())
   this.ensureDropDownModalInputVisibility();
  this.ensureDropDownApplyCommandState();
 },
 SetEnabled: function(enabled) {
  ASPxClientButtonEditBase.prototype.SetEnabled.call(this, enabled);
  this.ensureDropDownApplyCommandState();
 },
 GetDropDownButton: function(){
  return this.GetButton(this.dropDownButtonIndex);
 },
 GetButtonCollection: function(){
  var buttonElements = ASPxClientButtonEditBase.prototype.GetButtonCollection.call(this);
  var dropDownButtonElement = this.GetDropDownButton();
  if(ASPx.IsExists(dropDownButtonElement))
   buttonElements.push(dropDownButtonElement);
  return buttonElements;
 },
 GetPopupControl: function(){
  var pc = ASPx.GetControlCollection().Get(this.name + dropDownNameSuffix);
  if(pc && pc.GetWindowElement(-1))
   return pc;
  else
   return null;
 },
 GetDropDownWindow: function() {
  var pc = this.GetPopupControl();
  if(pc)
   return pc.GetWindowElement(-1);
  return null;
 },
 GetDropDownInnerControlName: function(suffix){
  var pc = this.GetPopupControl();
  if(pc)
   return this.GetPopupControl().name + suffix;
  return "";
 },
 GetDropDownItemImageCell: function() {
  return ASPx.GetNodesByPartialClassName(this.GetMainElement(), itemImageCellClassName)[0];
 },
 GetIsControlWidthWasChanged: function(){
  return this.mainElementWidthCache == ASPx.InvalidDimension || this.mainElementWidthCache != this.GetMainElement().clientWidth;
 },
 GetDropDownHeight: function(){
  return null;
 },
 GetDropDownWidth: function(){
  return null;
 },
 GetDropDownIsWindowElement: function(id, pcPostfix) {
  var pos = id.lastIndexOf(pcPostfix);
  if(pos != -1) {
   var name = id.substring(0, pos);
   var pc = ASPx.GetPopupControlCollection().Get(name);
   if(pc && pc.dropDownEditName)
    return aspxGetDropDownCollection().Get(pc.dropDownEditName);
  }
  return null;
 },
 GetDropDownParents: function() {
  var parents = [ ];
  var mainElement = this.GetMainElement();
  var element = mainElement.parentNode;
  while(element != null){
   if(element.tagName == "BODY")
    break;
   var dropDown = this.GetElementIsDropDownParent(element);
   if(dropDown != null)
    parents.push(dropDown);
   element = element.parentNode;
  }
  return parents.reverse();
 },
 GetElementIsDropDownParent: function(element) {
  return ASPx.Attr.IsExistsAttribute(element, "id") 
   ? this.GetDropDownIsWindowElement(ASPx.Attr.GetAttribute(element, "id"), ASPx.PCWIdSuffix + "-1") : null;
 },
 BeforePopupControlResizing: function() {
 },
 AfterPopupControlResizing: function() {
 },
 AfterPopupControlShown: function() {
 },
 ShowDropDownArea: function(isRaiseEvent, forceSize) {
  this.SetPCIsShowingNow(true);
  aspxGetDropDownCollection().RegisterDroppedDownControl(this, this.GetDropDownParents());
  if(!this.droppedDown) 
   this.SetLockListBoxClick();
  this.lockClosing = true; 
  var pc = this.GetPopupControl();
  var element = this.GetMainElement();
  var pcwElement = pc.GetCurrentWindowElement();
  pc.OnBeforeDropdownShow();
  if(ASPx.Browser.Chrome && pcwElement.clientHeight <= 0) 
   this.RestorePopupInsideNonStaticPositionedContainer();
  var height = forceSize ? forceSize.height : this.GetDropDownHeight();
  var width = forceSize ? forceSize.width : this.GetDropDownWidth();
  this.BeforePopupControlResizing();
  if(this.ddHeightCache != height || this.ddWidthCache != width || forceSize) {
   pc.SetSize(width, height);
   if(!forceSize) {
    this.ddHeightCache = height;
    this.ddWidthCache = width;
   }
  }
  this.AfterPopupControlResizing();
  if(ASPx.Browser.Chrome && pcwElement.clientHeight <= 0) 
   this.RestorePopupInsideNonStaticPositionedContainer();
  this.RaiseDropDownEventRequired = isRaiseEvent;
  pc.ShowAtElement(element, true);
  this.AfterPopupControlShown();
  this.droppedDown = true;
  this.lockClosing = false;
 },
 HideDropDownArea: function(isRaiseEvent){
  if(this.lockClosing || !this.droppedDown) return;
  if(!this.RaiseQueryCloseUp()) {
   return;
  }
  this.RemoveLockListBoxClick();
  this.DropDownButtonPop();
  var pc = this.GetPopupControl();
  if(pc){
   aspxGetDropDownCollection().UnregisterDroppedDownControl(this);
   pc.Hide();
   if(isRaiseEvent)
    this.RaiseCloseUp();
   this.droppedDown = false;
  }
 },
 RaiseLostFocus: function() {
  this.ensureDropDownClosedOnLostFocus();
  ASPxClientButtonEditBase.prototype.RaiseLostFocus.call(this);
 },
 ensureDropDownClosedOnLostFocus: function() {
  if(!this.isDropDownModal() && this.droppedDown)
   this.HideDropDownArea(true);
 },
 RestorePopupInsideNonStaticPositionedContainer: function() {
  var pc = this.GetPopupControl();
  var pcwElement = pc.GetCurrentWindowElement();
  var pcwParentElement = pcwElement.parentNode;
  var offsetParentElement = pcwElement.offsetParent;
  if(!offsetParentElement || offsetParentElement.tagName == "BODY") return;
  pcwParentElement.style.position = "relative";
  setTimeout(
   function() { 
    pcwParentElement.style.position = "";
    if(this.focused)
     pc.ShowAtElement(this.GetMainElement());
   }.aspxBind(this), 0);
 },
 SetLockListBoxClick: function() {
  this.lockListBoxClick = true;
 },
 RemoveLockListBoxClick: function() {
  delete this.lockListBoxClick;
 },
 ProcessInternalButtonClick: function(buttonIndex) {
  return this.dropDownButtonIndex == buttonIndex;
 },
 ToggleDropDown: function(){
  this.OnApplyChanges();
  if(this.droppedDown)
   this.HideDropDownArea(true);
  else
   this.ShowDropDownArea(true);  
 },
 GetTextInternal: function(){
  var text = ASPxClientButtonEditBase.prototype.GetValue.call(this);
  return text != null ? text : "";
 },
 SetTextInternal: function(text){
  if(!this.GetReadOnly())
   this.SetTextBase(text);
 },
 SetTextBase: function(text) {
  ASPxClientButtonEditBase.prototype.SetValue.call(this, text);
 },
 SetValue: function(value) {
  ASPxClientButtonEditBase.prototype.SetValue.call(this, value);
  this.SetLastSuccessText(this.GetTextInternal());
 },
 SetLastSuccessText: function(text){
  var tmpText = text;
  if(text == null) tmpText = "";
  else if(typeof(text) != "string")
     tmpText = text.toString();
  this.lastSuccessText = tmpText;
 },
 SetVisible: function(visible) {
  ASPxClientButtonEditBase.prototype.SetVisible.call(this, visible);
  if(!visible)
   this.HideDropDown();
 },
 RollbackTextInputValue: function () {
  this.SetTextBase(this.lastSuccessText);
 },
 SetPCIsShowingNow: function(value){
  this.pcIsShowingNow = value;
 },
 GetLastSuccesfullValue: function() {
  return this.lastSuccessText !== '' ? this.lastSuccessText : null;
 },
 CreateAriaExplanatoryTextManager: function() {
  if(this.accessibilityCompliant)
   return new DropDownAccessibilityExplanatoryTextManager(this);
  else 
   return new ASPx.DisableAccessibilityExplanatoryTextManager(this);
 },
 GetAccessibilityText: function() {
  var labelText = "";
  var helperContainer = this.GetAccessibilityAssistantElement();
  if(ASPx.IsExists(helperContainer))
   labelText = ASPx.Attr.GetAttribute(helperContainer, "aria-label");
  return !!labelText ? labelText : this.GetTextInternal();
 },
 GetAccessibilityActiveElements: function() {
  var helperContainer = this.GetAccessibilityAssistantElement();
  if(!this.accessibilityCompliant || !ASPx.IsExists(helperContainer))
   return [this.GetInputElement()];
  else if(ASPx.IsExists(this.accessibilityHelper))
   return [this.accessibilityHelper.GetActiveElement(true)];
  else 
   return [helperContainer];
 },
 OnValueChanged: function() {
  this.SetLastSuccessText(this.GetTextInternal());
  ASPxClientEdit.prototype.OnValueChanged.call(this);
 },
 OnApplyChanges: function(){
 },
 OnCancelChanges: function(){
  var isCancelProcessed = (this.GetTextInternal() != this.lastSuccessText);
  this.SetTextInternal(this.lastSuccessText);
  return isCancelProcessed;
 },
 OnFocus: function () {
  if(this.CorrectFocusWhenDisabled())
   return;
  if(ASPx.Browser.IE && this.needTimeoutForInputElementFocusEvent) {
   setTimeout(function () {
    this.OnFocusInternal();
    this.needTimeoutForInputElementFocusEvent = false;
   }.aspxBind(this), 0);
  } else
   this.OnFocusInternal();
 },
 OnFocusInternal: function() {
  this.OnSetFocus(true);
  ASPxClientButtonEditBase.prototype.OnFocus.call(this);
 },
 OnLostFocus: function(){
  this.OnSetFocus(false);
  ASPxClientButtonEditBase.prototype.OnLostFocus.call(this);
 },
 OnSetFocus: function(isFocused){
  aspxGetDropDownCollection().SetFocusedDropDownName(isFocused ? this.name : "");
 },
 IsEditorElement: function(element) {
  if(ASPxClientButtonEditBase.prototype.IsEditorElement.call(this, element))
   return true;
  if(this.allowFocusDropDownWindow)
   return false;
  var pc = this.GetPopupControl();
  if(pc != null) {
   var windowElement = pc.GetCurrentWindowElement();
   return windowElement == element || ASPx.GetIsParent(windowElement, element);
  }
  return false;
 },
 OnPopupControlShown: function(){
  this.SetPCIsShowingNow(false);
  if(this.RaiseDropDownEventRequired){
   this.RaiseDropDownEventRequired = false;
   window.setTimeout(function() { this.RaiseDropDown(); }.aspxBind(this), 0);
  }
 },
 IsCanToDropDown: function(){
  return true;
 },
 OnDropDown: function(evt) { 
  if(!this.isInitialized) 
   return true;
  if(evt.type === ASPx.TouchUIHelper.touchMouseDownEventName && ASPx.Evt.GetEventSource(evt) === this.GetInputElement())
   this.OnMouseDown();
  if(!this.IsCanToDropDown()) {
   this.ForceRefocusEditor(evt);
   return true;
  }
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera){
   if(!this.droppedDown) {
    ASPx.Evt.EmulateOnMouseDown(this.GetMainElement(), evt);
    ASPx.GetStateController().ClearSavedCurrentPressedElement();
   }
  }
  this.OnDropDownCore(evt);
  if(this.needCancelBubbleDropDownEvent())
   return ASPx.Evt.CancelBubble(evt); 
  return true;
 },
 OnDropDownCore: function(evt) {
  if(!this.droppedDown)
   this.DropDownButtonPush();
  this.ToggleDropDown();
  var isNativeFocus = this.isNativeFocus(evt);
  if(!isNativeFocus || !ASPx.Browser.MacOSMobilePlatform)
   this.ForceRefocusEditor(evt, isNativeFocus);
 },
 isNativeFocus: function(evt) {
  var inputElement = this.GetInputElement();
  return !!inputElement ? this.IsElementBelongToInputElement(ASPx.Evt.GetEventSource(evt)) : false;
 },
 needCancelBubbleDropDownEvent: function() {
  return true;
 },
 DropDownButtonPush: function(){
  if(this.droppedDown || this.ddButtonPushed) return;
  this.ddButtonPushed = true;
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera)
   this.DropDownButtonPushPop(true);
  else
   this.DropDownButtonPushMozilla();
 }, 
 DropDownButtonPop: function(force){
  if((!this.droppedDown || !this.ddButtonPushed) && !force) return;
  this.ddButtonPushed = false;
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera)
   this.DropDownButtonPushPop(false);
  else
   this.DropDownButtonPopMozilla();
 },
 DropDownButtonPushPop: function(isPush){
  var buttonElement = this.GetDropDownButton();
  if(buttonElement){
   var controller = ASPx.GetStateController();
   var element = controller.GetPressedElement(buttonElement);
   if(element){
    if(isPush){
     controller.SetCurrentHoverElement(null);
     controller.DoSetPressedState(element);
    } else {
     controller.DoClearPressedState(element);
     controller.SetCurrentPressedElement(null);
     controller.SetCurrentHoverElement(element);
    }
   }
  }
 },
 DropDownButtonPushMozilla: function(){
  this.DisableStyleControllerForDDButton();
  var controller = ASPx.GetStateController();
  controller.savedCurrentPressedElement = null;
 },
 DropDownButtonPopMozilla: function(){
  this.EnableStyleControllerForDDButton();
  var controller = ASPx.GetStateController();
  var buttonElement = this.GetDropDownButton();
  if(buttonElement){
   var element = controller.GetPressedElement(buttonElement);
   if(element)
    controller.DoClearPressedState(element);
   controller.currentPressedElement = null;
   element = controller.GetHoverElement(buttonElement);
   if(element)
    controller.SetCurrentHoverElement(element);
  }
 },
 EnableStyleControllerForDDButton: function(){
  var element = this.GetDropDownButton();
  if(element){
   var controller = ASPx.GetStateController();
   this.ReplaceElementControlStyleItem(controller.hoverItems, ASPx.HoverItemKind, element, this.ddButtonHoverStyle);
   this.ReplaceElementControlStyleItem(controller.pressedItems, ASPx.PressedItemKind, element, this.ddButtonPressedStyle);
   this.ReplaceElementControlStyleItem(controller.selectedItems, ASPx.SelectedItemKind, element, this.ddButtonSelectedStyle);
  }
 },
 DisableStyleControllerForDDButton: function(){
  var element = this.GetDropDownButton();
  if(element){
   var controller = ASPx.GetStateController();
   this.ddButtonHoverStyle = this.ReplaceElementControlStyleItem(controller.hoverItems, ASPx.HoverItemKind, element, null);
   this.ddButtonPressedStyle = this.ReplaceElementControlStyleItem(controller.pressedItems, ASPx.PressedItemKind, element, null);
   this.ddButtonSelectedStyle = this.ReplaceElementControlStyleItem(controller.selectedItems, ASPx.SelectedItemKind, element, null);
  }
 },
 ReplaceElementControlStyleItem: function(items, kind, element, newStyleItem){
  var styleItem = items[element.id];
  items[element.id] = newStyleItem;
  element[kind] = newStyleItem;
  return styleItem;
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing){
  if(!causedByWindowResizing || !this.pcIsShowingNow)
   this.HideDropDownArea(true);
 },
 OnDocumentMouseUp: function() {
  this.DropDownButtonPop();
 },
 OnDDButtonMouseMove: function(evt){
 },
 ShouldCloseOnMCMouseDown: function () {
  return true;
 },
 OnMainCellMouseDown: function (evt) {
  if(this.ShouldCloseOnMCMouseDown())
   this.OnCloseUp(evt);
 },
 OnCloseUp: function (evt) {
  if(ASPx.Browser.IE) {
   this.needTimeoutForInputElementFocusEvent = true;
   setTimeout(function () { this.HideDropDownArea(true); }.aspxBind(this), 0);
  } else {
   this.HideDropDownArea(true);
  }
 },
 OnOpenAnotherDropDown: function(){
  this.HideDropDownArea(true);
 },
 OnTextChanged: function() {
  if(!this.ChangedByEnterKeyPress())
   this.OnTextChangedInternal();
 },
 OnTextChangedInternal: function() {
  this.ParseValue();
 },
 ChangedByEnterKeyPress: function() {
  if(ASPx.Browser.Firefox || ASPx.Browser.WebKitFamily) 
   if(this.enterKeyPressed) {
    this.enterKeyPressed = false;
    return true;
   } 
  return false;
 },
 ChangeEnabledAttributes: function(enabled){
  ASPxClientButtonEditBase.prototype.ChangeEnabledAttributes.call(this, enabled);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   this.ChangeButtonEnabledAttributes(btnElement, this.GetChangeButtonEnabledAttributesMethod(enabled));
  var inputElement = this.GetInputElement();
  if(inputElement)
   this.ChangeInputCellEnabledAttributes(inputElement.parentNode, ASPx.Attr.ChangeAttributesMethod(enabled));
  var imageCell = this.GetDropDownItemImageCell();
  if(ASPx.IsExists(imageCell))
   this.ChangeImageCellEnabledAttributes(imageCell, ASPx.Attr.ChangeAttributesMethod(enabled));
 },
 ChangeEnabledStateItems: function(enabled){
  ASPxClientButtonEditBase.prototype.ChangeEnabledStateItems.call(this, enabled);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   ASPx.GetStateController().SetElementEnabled(btnElement, enabled);
 },
 ChangeInputCellEnabledAttributes: function(element, method){
  method(element, "onclick");
  method(element, "onkeyup");
  if(ASPx.Browser.Edge)
   method(element, "onmousedown");
  method(element, "on" + ASPx.TouchUIHelper.touchMouseDownEventName);
  method(element, "on" + ASPx.TouchUIHelper.touchMouseUpEventName);
 },
 ChangeImageCellEnabledAttributes: function(imageCell, method){
  method(imageCell, "onmousedown");
 },
 InitializeKeyHandlers: function() {
  this.AddKeyDownHandler(ASPx.Key.Enter, "OnEnter");
  this.AddKeyDownHandler(ASPx.Key.Esc, "OnEscape");
  this.AddKeyDownHandler(ASPx.Key.PageUp, "OnPageUp");
  this.AddKeyDownHandler(ASPx.Key.PageDown, "OnPageDown");
  this.AddKeyDownHandler(ASPx.Key.End, "OnEndKeyDown");
  this.AddKeyDownHandler(ASPx.Key.Home, "OnHomeKeyDown");
  this.AddKeyDownHandler(ASPx.Key.Left, "OnArrowLeft");
  this.AddKeyDownHandler(ASPx.Key.Right, "OnArrowRight");
  this.AddKeyDownHandler(ASPx.Key.Up, "OnArrowUp");
  this.AddKeyDownHandler(ASPx.Key.Down, "OnArrowDown");
  this.AddKeyDownHandler(ASPx.Key.Tab, "OnTab");
 },
 OnArrowUp: function(evt){
  if(evt.altKey) {
   this.ToggleDropDown();
   return true;
  }
  return false;
 },
 OnArrowDown: function(evt){
  if(evt.altKey) {
   this.ToggleDropDown();
   return true;
  }
  return false;
 },
 OnPageUp: function(evt){
  return false;
 }, 
 OnPageDown: function(evt){
  return false;
 },
 OnEndKeyDown: function(evt){
  return false;
 },
 OnHomeKeyDown: function(evt){
  return false;
 },
 OnArrowLeft: function(evt){
  return false;
 },
 OnArrowRight: function(evt){
  return false;
 },
 OnEscape: function(evt){
  return this.OnEscapeInternal();
 },
 OnEscapeInternal: function() {
  var isCancelProcessed = this.OnCancelChanges() || this.droppedDown;
  this.HideDropDownArea(true);
  return isCancelProcessed;
 },
 OnEnter: function(evt){
  return false;
 },
 OnTab: function(evt){
  return false;
 },
 isDropDownModal: function(undefinedIfPopupIsDifferent) {
  var result = this.ddmBP && window.innerWidth < this.ddmBP;
  if(undefinedIfPopupIsDifferent) {
   var pc = this.GetPopupControl();
   if(pc && pc.GetAdaptiveModalMode(-1) != result)
    return undefined;
  }
  return !!result;
 },
 onDropDownModalChanged: function(enabled) {
  if(!this.ddmInput)
   return;
  if(enabled)
   this.enableDropDownModal();
  else
   this.disableDropDownModal();
  if(this.focusedNullTextElement)
   this.ensureAdjustFocusedNullTextElement();
 },
 enableDropDownModal: function() {
  this.loadMainElementHeight();
  var pc = this.GetPopupControl();
  var contentContainer = pc.GetContentContainer(-1);
  var inputContainer = contentContainer.querySelector(".dxdd-input");
  var inputElement = this.GetInputElement();
  inputContainer.appendChild(inputElement);
  if(this.focusedNullTextElement)
   inputContainer.appendChild(this.focusedNullTextElement);
  this.initializeDropDownModalClearButton(inputContainer);
  if(this.dropDownModalClearButton)
   this.EnsureClearButtonVisibility();
  this.ensureDropDownModalInputVisibility(inputContainer);
 },
 disableDropDownModal: function() {
  this.resetMainElementHeight();
  var inputElement = this.GetInputElement();
  this.getInputCell().appendChild(inputElement);
  if(this.focusedNullTextElement)
   this.getInputCell().appendChild(this.focusedNullTextElement);
 },
 loadMainElementHeight: function() {
  var mainElement = this.GetMainElement();
  var mainElementHeight = mainElement.style.height;
  if(!mainElementHeight) {
   var currentHeight = mainElement.getBoundingClientRect().height;
   mainElement.style.height = currentHeight + "px";
   ASPx.Attr.SetAttribute(mainElement, "data-hasAssignedHeight", true);
  }
 },
 resetMainElementHeight: function() {
  var mainElement = this.GetMainElement();
  var hasAssignedHeight = ASPx.Attr.GetAttribute(mainElement, "data-hasAssignedHeight");
  if(hasAssignedHeight) {
   mainElement.style.height = "";
   ASPx.Attr.RemoveAttribute(mainElement, "data-hasAssignedHeight");
  }
 },
 ensureDropDownModalInputVisibility: function(inputContainer) {
  if(!inputContainer && this.ddmInput) {
   var pc = this.GetPopupControl();
   inputContainer = pc && pc.GetContentContainer(-1).querySelector(".dxdd-input");
  }
  if(!inputContainer)
   return;
  ASPx.ToggleClassNameToElement(inputContainer, "dxdd-readonly", this.GetReadOnly() || !this.GetEnabled());
 },
 onDropDownCommandButtonClick: function(command) {
  if(command === CONSTANTS.DROPDOWN_COMMAND_APPLY)
   this.onDropDownApplyCommandClick();
  this.onDropDownCloseCommandClick();
 },
 onDropDownApplyCommandClick: function() {
  throw "Not Implemented";
 },
 onDropDownCloseCommandClick: function() {
  throw "Not Implemented";
 },
 ensureDropDownApplyCommandState: function() {
  if(!this.dropDownCommandButtons)
   return;
  var button = this.dropDownCommandButtons[CONSTANTS.DROPDOWN_COMMAND_APPLY];
  if(button)
   button.SetEnabled(this.isDropDownApplyCommandEnabled());
 },
 isDropDownApplyCommandEnabled: function() {
  return this.GetEnabled() && !this.GetReadOnly();
 },
 initializeDropDownModalClearButton: function(inputContainer) {
  if(this.dropDownModalClearButton === undefined) {
   this.dropDownModalClearButton = inputContainer.querySelector(this.getDropDownModalClearButtonSelector()) || null;
   if(this.dropDownModalClearButton)
    ASPx.Evt.AttachEventToElement(this.dropDownModalClearButton, "click", this.onClearButtonClick.bind(this));
  }
 },
 getDropDownModalClearButtonSelector: function() {
  return ".dxdd-clearbutton";
 },
 EnsureClearButtonVisibility: function() {
  ASPxClientButtonEditBase.prototype.EnsureClearButtonVisibility.call(this);
  if(this.dropDownModalClearButton && this.isDropDownModal())
   ASPx.SetElementDisplay(this.dropDownModalClearButton, this.RequireShowClearButton());
 },
 applyFormLayoutItemSettings: function(settings) {
  var pc = this.GetPopupControl();
  if(pc)
   this.initializeDropDownContent(pc, settings.caption, settings.helpText);
  else
   this.flSettings = settings;
 },
 getInputCell: function() {
  var cell = ASPxClientButtonEditBase.prototype.getInputCell.call(this);
  return ASPx.ElementHasCssClass(cell, "dxic") ? cell : this.GetMainElement().querySelector(".dxic");
 },
 RaiseCloseUp: function(){
  if(!this.CloseUp.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.CloseUp.FireEvent(this, args);
  }
 },
 RaiseDropDown: function(){
  if(!this.DropDown.IsEmpty() && this.isInitialized){
   var args = new ASPxClientEventArgs();
   this.DropDown.FireEvent(this, args);
  }
 },
 RaiseQueryCloseUp: function(){
  if(!this.QueryCloseUp.IsEmpty() && this.isInitialized) {
   var args = new ASPxClientCancelEventArgs();
   this.QueryCloseUp.FireEvent(this, args);
   return !args.cancel;
  }
  return true;
 },
 AdjustDropDownWindow: function(){
  var pc = this.GetPopupControl();
  if(pc) {
   if(ASPx.Browser.IE)
    ASPx.GetPopupControlCollection().LockWindowResizeByBodyScrollVisibilityChanging();
   pc.AdjustSize();
   pc.UpdatePositionAtElement(this.GetMainElement());
   if(ASPx.Browser.IE)
    ASPx.GetPopupControlCollection().UnlockWindowResizeByBodyScrollVisibilityChanging();
  }
 },
 ResetDropDownSizeCache: function(){
  this.ddHeightCache = ASPx.InvalidDimension;
  this.ddWidthCache = ASPx.InvalidDimension;
 },
 ShowDropDown: function(){
  if(!this.droppedDown)
   this.ShowDropDownArea(false);
 },
 HideDropDown: function(){
  if(this.droppedDown)
   this.HideDropDownArea(false);
 }
});
var ASPxClientDropDownEdit = ASPx.CreateClass(ASPxClientDropDownEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.LostFocusInternal = new ASPxClientEvent();
  this.dropDownWindowHeight = "";
  this.dropDownWindowWidth = "";
  this.allowFocusDropDownWindow = true;
  this.needAdjustControlsInDropDownWindow = true;
  this.DropDownCommandButtonClick = new ASPxClientEvent();
 },
 InlineInitialize: function(){
  this.InitSpecialKeyboardHandling();
  ASPxClientDropDownEditBase.prototype.InlineInitialize.call(this);
 },
 getDropDownEventTargets: function() {
  return ASPxClientDropDownEditBase.prototype.getDropDownEventTargets.call(this).concat([
   this.shouldDropDownOnMCMouseDown() ? this.getInputCell() : null,
  ]);
 },
 shouldDropDownOnMCMouseDown: function() {
  return this.readOnly || !this.allowUserInput;
 },
 ShouldCloseOnMCMouseDown: function() {
  return !this.shouldDropDownOnMCMouseDown();
 },
 InitializeEvents: function() {
  this.LostFocus.AddHandler(this.ProcessLostFocus.aspxBind(this));
  this.QueryCloseUp.AddHandler(this.ProcessQueryCloseUp.aspxBind(this));
  ASPxClientDropDownEditBase.prototype.InitializeEvents.call(this);
 },
 RefocusOnClickRequired: function(){
  return ASPx.Browser.IE;
 },
 BeforePopupControlResizing: function() {
  var divContainer = this.GetDropDownDivContainer();
  if(divContainer && this.needAdjustControlsInDropDownWindow) {
   this.AdjustControlsInDropDownWindow();
   ASPx.SetElementDisplay(divContainer, false);
  }
 },
 AfterPopupControlResizing: function() {
  var divContainer = this.GetDropDownDivContainer();
  if(divContainer && this.needAdjustControlsInDropDownWindow) {
   ASPx.SetElementDisplay(divContainer, true);
   this.AdjustControlsInDropDownWindow();
   this.needAdjustControlsInDropDownWindow = false;
  }
 },
 AdjustControlsInDropDownWindow: function() {
  var pc = this.GetPopupControl();
  var pcwElement = pc.GetCurrentWindowElement();
  ASPx.GetControlCollection().ProcessControlsInContainer(pcwElement, function(control) {
   control.AdjustControl(false);
  });
 },
 GetDropDownDivContainer: function() {
  return ASPx.GetElementById(this.name + dropDownNameSuffix + "_DDDC");
 },
 GetDropDownHeight: function(){
  if(this.dropDownWindowHeight != "")
   return this.dropDownWindowHeight;
  return ASPxClientDropDownEditBase.prototype.GetDropDownHeight.call(this);
 },
 GetDropDownWidth: function(){
  if(this.dropDownWindowWidth != "")
   return this.dropDownWindowWidth;
  return this.GetMainElement().offsetWidth;
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing){
  if(!ASPx.GetPopupControlCollection().WindowResizeByBodyScrollVisibilityChangingLocked())
   ASPxClientDropDownEditBase.prototype.CloseDropDownByDocumentOrWindowEvent.call(this, causedByWindowResizing);
 },
 OnBrowserWindowResize: function(e){
  this.needAdjustControlsInDropDownWindow = true;
 },
 OnEnter: function(evt){
  return this.droppedDown;
 },
 OnEscape: function(evt){
  var isCancelProcessed = this.droppedDown;
  this.HideDropDownArea(true);
  return isCancelProcessed;
 },
 OnTextChanged: function() {
  this.OnValueChanged();
 },
 ProcessLostFocus: function() {
  if(!this.droppedDown)
   this.RaiseLostFocusInternal();
 },
 ProcessQueryCloseUp: function() {
  if(this.focused)
   return;
  var forceRefocusTimeout = 150;
  setTimeout(function() {
   if(!this.IsDropDownContainsFocus())
    this.RaiseLostFocusInternal();
  }.aspxBind(this), forceRefocusTimeout);
 },
 IsDropDownContainsFocus: function() {
  return ASPx.GetIsParent(this.GetDropDownWindow(), ASPx.GetActiveElement());
 },
 GetKeyValueInternal: function(){
  if(ASPx.IsExists(this.stateObject))
   return this.stateObject.keyValue;
  return null;
 },
 SetKeyValueInternal: function(keyValue){
  this.UpdateStateObjectWithObject({ keyValue: keyValue });
 },
 GetValueString: function() {
  var value = this.GetKeyValue();
  return (value == null) ? ASPxClientDropDownEditBase.prototype.GetValueString.call(this) : value.toString();
 },
 onDropDownCommandButtonClick: function(action) {
  this.raiseDropDownCommandButtonClick(action);
 },
 raiseDropDownCommandButtonClick: function(command) {
  var args = new ASPxClientDropDownCommandEventArgs(command);
  if(!this.DropDownCommandButtonClick.IsEmpty())
   this.DropDownCommandButtonClick.FireEvent(this, args);
  return !args.cancel;
 },
 GetKeyValue: function(){
  return this.GetKeyValueInternal();
 },
 SetKeyValue: function(keyValue){
  this.SetKeyValueInternal(keyValue);
 },
 RaiseLostFocusInternal: function() {
  if(!this.isInitialized)
   return;
  this.ensureDropDownClosedOnLostFocus();
  if(this.LostFocusInternal.IsEmpty())
   return;
  var args = new ASPxClientEventArgs();
  this.LostFocusInternal.FireEvent(this, args);
 },
 ensureDropDownClosedOnLostFocus: function() { }
});
ASPxClientDropDownEdit.Cast = ASPxClientControl.Cast;
var ASPxClientDropDownCollection = ASPx.CreateClass(ASPxClientControlCollection, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
  this.droppedControlName = "";
  this.droppedParentNames = [ ];
  this.focusedControlName = "";
 },
 GetCollectionType: function(){
  return "DropDown";
 },
 SetFocusedDropDownName: function(name){
  this.focusedControlName = name;
 },
 ResetDroppedDownControl: function(){
  this.droppedControlName = "";
 },
 ResetDroppedDownParentCollection: function(startDroppedDownControlName) {
  var regArray = [ ];
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == startDroppedDownControlName)
    break;
   regArray.push(this.droppedParentNames[i]);
  }
  this.droppedParentNames = regArray;
  if(this.droppedParentNames.length > 0) {
   this.droppedControlName = this.droppedParentNames[this.droppedParentNames.length - 1];
   ASPx.Data.ArrayRemoveAt(this.droppedParentNames, this.droppedParentNames.length - 1);
  }
 },
 ResetFocusedControl: function(){
  this.focusedControlName = "";
 },
 GetFocusedDropDown: function(){
  var control = this.GetDropDownControlInternal(this.focusedControlName);
  if(control == null) this.ResetFocusedControl();
  return control;
 },
 GetDroppedDropDown: function(){
  var control = this.GetDropDownControlInternal(this.droppedControlName);
  if(control == null) this.ResetDroppedDownControl();
  return control;
 },
 GetDroppedDropDownParents: function(startDroppedDownControlName) {
  var dropDownArray = [ ];
  var isNeedGetControl = false;
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == startDroppedDownControlName) isNeedGetControl = true;
   if(isNeedGetControl) {
    var control = this.GetDropDownControlInternal(this.droppedParentNames[i]);
    if(control != null)
     dropDownArray.push(control);
   }
  }
  return dropDownArray;
 },
 FindFirstNameForClose: function(newDroppedDownParentArray) {
  var firstNameToClose = newDroppedDownParentArray.length > 0 ? "" : this.droppedParentNames[i];
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(ASPx.Data.ArrayIndexOf(newDroppedDownParentArray, this.Get(this.droppedParentNames[i])) == -1) {
    firstNameToClose = this.droppedParentNames[i];
    break;
   }
  }
  return firstNameToClose;
 },
 GetDropDownControlInternal: function(name){
  var control = this.Get(name);
  var isControlExists = control && !control.IsDOMDisposed();
  if(!isControlExists)
   control = null;
  return control;
 },
 IsDroppedDropDownParentExist: function(name) {
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == name)
    return true;
  }
  return false;
 },
 OnDDButtonMouseMove: function(evt){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null)
   dropDownControl.OnDDButtonMouseMove(evt);
 },
 OnDocumentMouseDown: function(evt){
  if(ASPxClientControl.documentDropDownMouseDownLocked) return; 
  if(!ASPx.TouchUIHelper.handleFastTapIfRequired(evt, function(){ this.CloseDropDownByDocumentOrWindowEvent(evt, false); }.aspxBind(this), false))
   this.CloseDropDownByDocumentOrWindowEvent(evt, false);
 },
 OnDocumentMouseUp: function(evt){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null)
   dropDownControl.OnDocumentMouseUp();
 },
 OnBrowserWindowResize: function(e){
  if(typeof(ASPx.GetPopupControlCollection) != "undefined" && !ASPx.GetPopupControlCollection().WindowResizeByBodyScrollVisibilityChangingLocked()){
   this.CloseDropDownByDocumentOrWindowEvent(e.htmlEvent, true);
   this.AdjustControls();
  }
 },
 CloseDropDownByDocumentOrWindowEvent: function(evt, causedByWindowResizing){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null && (this.IsEventNotFromControlSelf(evt, dropDownControl) || causedByWindowResizing))
   dropDownControl.CloseDropDownByDocumentOrWindowEvent(causedByWindowResizing);
  var childrenDropDownsToClose = this.GetDroppedDropDownParents(this.droppedParentNames[0]);
  if(childrenDropDownsToClose.length != 0) {
   childrenDropDownsToClose = childrenDropDownsToClose.reverse();
   this.ResetDroppedDownParentCollection(this.droppedParentNames[0]);
   var rollbackDroppedDownNames = [ ];
   for(var c = 0; c < childrenDropDownsToClose.length; c++) {
    if(this.IsEventNotFromControlSelf(evt, childrenDropDownsToClose[c]))
     childrenDropDownsToClose[c].CloseDropDownByDocumentOrWindowEvent(causedByWindowResizing);
    else
     rollbackDroppedDownNames.push(childrenDropDownsToClose[c].name);
   }
   if(rollbackDroppedDownNames != 0) {
    rollbackDroppedDownNames = rollbackDroppedDownNames.reverse();
    this.droppedParentNames = rollbackDroppedDownNames;
   }
  }
 },
 AdjustControls: function(){
  this.ForEachControl(function(control) {
   control.AdjustControl(false);
  });
 },
 IsEventNotFromControlSelf: function(evt, control){
  var srcElement = ASPx.Evt.GetEventSource(evt);
  var mainElement = control.GetMainElement();
  var dropDownWindow = control.GetDropDownWindow();
  if(!srcElement || !mainElement || !dropDownWindow) return true;
  return (!ASPx.GetIsParent(mainElement, srcElement) &&
   !ASPx.GetIsParent(dropDownWindow, srcElement) &&
   !this.IsEventFromSharedPopupOfInnerEditor(dropDownWindow, srcElement));
 },
 IsEventFromSharedPopupOfInnerEditor: function(dropDownWindow, srcElement) {
  var eventFromPopupOfInnerEditor = false;
  ASPx.GetControlCollection().ProcessControlsInContainer(dropDownWindow,
   function(control){
    if(control.calendarOwnerName) {
     var sharedCalendarPopup = control.GetCalendarOwner().GetDropDownWindow();
     if(ASPx.GetIsParent(sharedCalendarPopup, srcElement))
      eventFromPopupOfInnerEditor = true;
    }
  });
  return eventFromPopupOfInnerEditor;
 },
 RegisterDroppedDownControl: function(dropDownControl, droppedDownParentArray){
  var prevDropDownControl = this.GetDroppedDropDown();
  var areDroppedDownsCollectionParents = ASPx.Data.ArrayIndexOf(droppedDownParentArray, prevDropDownControl) != -1;
  if(prevDropDownControl != null && prevDropDownControl != dropDownControl && !areDroppedDownsCollectionParents)
   prevDropDownControl.OnOpenAnotherDropDown();
  if(this.droppedParentNames.length > 0) {
   var firstDropDownsNameToClose = this.FindFirstNameForClose(droppedDownParentArray);
   if(firstDropDownsNameToClose != "") {
    var childrenDropDownsToClose = this.GetDroppedDropDownParents(firstDropDownsNameToClose);
    this.ResetDroppedDownParentCollection(firstDropDownsNameToClose);
    this.CloseDroppedDownCollection(childrenDropDownsToClose.reverse());
   }
  }
  this.droppedControlName = dropDownControl.name;
  this.droppedParentNames = [ ];
  for(var i = 0; i < droppedDownParentArray.length; i++)
   this.droppedParentNames.push(droppedDownParentArray[i].name);
 },
 UnregisterDroppedDownControl: function(dropDownControl){
  if(this.droppedControlName == dropDownControl.name)
   this.ResetDroppedDownControl();
  if(this.IsDroppedDropDownParentExist(dropDownControl.name)) {
   var prevDropDownControl = this.GetDroppedDropDown();
   if(prevDropDownControl != null)
    prevDropDownControl.OnOpenAnotherDropDown();
   var childrenDropDownsToClose = this.GetDroppedDropDownParents(dropDownControl.name);
   this.ResetDroppedDownParentCollection(dropDownControl.name);
   ASPx.Data.ArrayRemoveAt(childrenDropDownsToClose, 0);
   this.CloseDroppedDownCollection(childrenDropDownsToClose.reverse());
  }
 },
 CloseDroppedDownCollection: function(dropDownParentArray) {
  for(var c = 0; c < dropDownParentArray.length; c++)
   dropDownParentArray[c].OnOpenAnotherDropDown();
 }
});
var DropDownAccessibilityExplanatoryTextManager = ASPx.CreateClass(ASPx.EditAccessibilityExplanatoryTextManager , {
 constructor: function(editor) {
  this.constructor.prototype.constructor.call(this, editor);
 },
 SetHelperLabel: function() {
  var pronounceText = this.editor.GetAccessibilityText();
  var labelElements = ASPx.FindAssociatedLabelElements(this.editor);
  if(labelElements.length > 0) {
   var labelText = labelElements.map(function(label) { return ASPx.GetInnerText(label); }).join(" ");
   if(pronounceText.indexOf(labelText) < 0)
    pronounceText = labelText + " " + pronounceText;
  }
  var pronounceElement = !!this.editor.accessibilityHelper ? 
   this.editor.accessibilityHelper.getItem(true) : 
   this.editor.GetAccessibilityAssistantElement();
  ASPx.Attr.SetAttribute(pronounceElement, "aria-label", pronounceText);
  var textElement = this.GetTextElement();
  if(ASPx.IsExists(textElement)) {
   if(!ASPx.IsExists(ASPx.Attr.GetAttribute(this.editor.GetInputElement(), 'aria-activedescendant')))
    pronounceElement = this.editor.GetInputElement();
   this.SetOrRemoveText([pronounceElement], textElement, true, false, false);
   setTimeout(function() {
    this.SetOrRemoveText([pronounceElement], textElement, false, false, false);
   }.aspxBind(this), 500);
  }
 }
});
var ASPxClientDropDownCommandEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function (command) {
  this.constructor.prototype.constructor.call(this);
  this.commandName = command;
 }
});
var dropDownCollection = null;
function aspxGetDropDownCollection() {
 if(dropDownCollection == null)
  dropDownCollection  = new ASPxClientDropDownCollection();
 return dropDownCollection;
}
ASPx.Ident.IsASPxClientDateEdit = function(obj) {
 return !!obj.isASPxClientDateEdit;
};
ASPx.DDMC_MD = function(name, evt) {
 var dd = ASPx.GetControlCollection().Get(name);
 if(dd)
  dd.OnMainCellMouseDown(evt);
};
ASPx.DDBPCShown = function(name){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnPopupControlShown();
};
ASPx.CBLBSelectedIndexChanged = function(name, evt){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnLBSelectedIndexChanged();
};
ASPx.CBLBItemMouseUp = function(name, evt){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnListBoxItemMouseUp(evt);
};
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseDownEventName, function(evt) {
 return aspxGetDropDownCollection().OnDocumentMouseDown(evt);
});
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseUpEventName, function(evt) {
 return aspxGetDropDownCollection().OnDocumentMouseUp(evt);
});
window.ASPxClientDropDownEditBase = ASPxClientDropDownEditBase;
window.ASPxClientDropDownEdit = ASPxClientDropDownEdit;
ASPx.GetDropDownCollection = aspxGetDropDownCollection;
})();

